/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.Logger
 *  fire.pb.map.Role
 *  fire.pb.map.RoleManager
 *  fire.pb.npc.SHeroBaseInfo
 *  fire.pb.npc.SHeroWeekFreeInfo
 *  fire.pb.util.CalendarUtil
 *  gnet.link.Onlines
 *  mkdb.Transaction
 *  mkio.Protocol
 *  xbean.HuoBanColumn
 *  xbean.HuoBanInfo
 *  xbean.HuoBanZhenrongInfo
 *  xbean.Pod
 *  xtable.Huobancolumns
 *  xtable.Properties
 */
package fire.pb.huoban;

import fire.log.Logger;
import fire.pb.huoban.HuoBan;
import fire.pb.huoban.HuoBanDetailInfo;
import fire.pb.huoban.HuoBanInfo;
import fire.pb.huoban.HuoBanZhenRongColumn;
import fire.pb.huoban.Module;
import fire.pb.huoban.SHuobanList;
import fire.pb.huoban.SZhenrongInfo;
import fire.pb.huoban.ZhenrongInfo;
import fire.pb.map.Role;
import fire.pb.map.RoleManager;
import fire.pb.npc.SHeroBaseInfo;
import fire.pb.npc.SHeroWeekFreeInfo;
import fire.pb.util.CalendarUtil;
import gnet.link.Onlines;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import mkdb.Transaction;
import mkio.Protocol;
import xbean.HuoBanZhenrongInfo;
import xbean.Pod;
import xtable.Huobancolumns;
import xtable.Properties;

public class HuoBanColumn {
    private static final Logger logger = Logger.getLogger((String)"HUOBAN");
    final long roleId;
    final boolean readonly;
    final xbean.HuoBanColumn huobancolumn;

    public static HuoBanColumn getHuoBanColumn(long roleId, boolean readonly) {
        if (Properties.select((Long)roleId) == null) {
            logger.error((Object)("构造HuoBanColumn时，角色 " + roleId + " 不存在。"));
            return null;
        }
        xbean.HuoBanColumn col = null;
        col = readonly ? Huobancolumns.select((Long)roleId) : Huobancolumns.get((Long)roleId);
        if (col == null) {
            if (readonly) {
                col = Pod.newHuoBanColumnData();
            } else {
                col = Pod.newHuoBanColumn();
                Huobancolumns.insert((Long)roleId, (xbean.HuoBanColumn)col);
            }
        }
        return new HuoBanColumn(roleId, col, readonly);
    }

    private HuoBanColumn(long roleId, xbean.HuoBanColumn column, boolean readonly) {
        this.roleId = roleId;
        this.huobancolumn = column;
        this.readonly = readonly;
    }

    public HuoBan getHuoBan(int huobanId) {
        xbean.HuoBanInfo info = (xbean.HuoBanInfo)this.huobancolumn.getHuobans().get(huobanId);
        if (info == null) {
            return null;
        }
        return HuoBan.getHuoBan(info, this.readonly);
    }

    public HuoBanDetailInfo getHuoBanDetailInfo(int huoBanId) {
        HuoBanDetailInfo sDetailInfo = new HuoBanDetailInfo();
        HuoBan huoban = this.getHuoBan(huoBanId);
        if (huoban == null) {
            return null;
        }
        sDetailInfo.huobanid = huoBanId;
        sDetailInfo.infight = huoban.getInfight();
        sDetailInfo.weekfree = huoban.getWeekFree();
        sDetailInfo.state = huoban.getHuoBanFinalState();
        Map<Integer, Float> finalAttrs = huoban.getL2Attrs(this.roleId);
        for (Map.Entry<Integer, Float> entry : finalAttrs.entrySet()) {
            sDetailInfo.datas.add(entry.getValue().intValue());
        }
        return sDetailInfo;
    }

    public HuoBanInfo getHuoBanInfo(int huoBanId) {
        HuoBanInfo sInfo = new HuoBanInfo();
        HuoBan huoban = this.getHuoBan(huoBanId);
        if (huoban == null) {
            return null;
        }
        sInfo.huobanid = huoBanId;
        sInfo.infight = huoban.getInfight();
        sInfo.state = huoban.getHuoBanFinalState();
        sInfo.weekfree = huoban.getWeekFree();
        return sInfo;
    }

    public int getHuoBanInfoByType(int type, List<Integer> huobanKeys, List<Integer> nowhuobanKeys) {
        for (xbean.HuoBanInfo huobanInfo : this.huobancolumn.getHuobans().values()) {
            if (huobanInfo.getState() == 0 || huobanKeys.contains(huobanInfo.getId()) || nowhuobanKeys.contains(huobanInfo.getId()) || huobanInfo.getType() != type) continue;
            return huobanInfo.getId();
        }
        for (xbean.HuoBanInfo huobanInfo : this.huobancolumn.getHuobans().values()) {
            if (huobanInfo.getState() == 0 || huobanKeys.contains(huobanInfo.getId()) || nowhuobanKeys.contains(huobanInfo.getId())) continue;
            return huobanInfo.getId();
        }
        return 0;
    }

    public void setWeekFreeHuoBan() {
        ArrayList<Integer> weekFreeHuoban = new ArrayList<Integer>();
        SHeroWeekFreeInfo weekfree = Module.getInstance().getHeroWeekFreeInfo();
        if (weekfree == null) {
            Module.logger.error((Object)new StringBuilder().append("week free is null:").append(this.roleId));
            return;
        }
        weekFreeHuoban.addAll(weekfree.getHeros());
        int vipCount = this.huobancolumn.getViphuoban();
        if (vipCount != 0) {
            for (int i = 0; i < vipCount; ++i) {
                Integer huobanid = (Integer)weekfree.vipheros.get(i);
                if (huobanid == null) continue;
                weekFreeHuoban.add(huobanid);
            }
        }
        long nowTime = System.currentTimeMillis();
        block8: for (Integer huobanId : this.getAllHuoBans().keySet()) {
            HuoBan huoban = this.getHuoBan(huobanId);
            int nState = huoban.getHuoBanState();
            Long finalState = huoban.getHuoBanFinalState();
            if (weekFreeHuoban.contains(huobanId)) {
                switch (nState) {
                    case 0: {
                        huoban.setHuoBanState(2);
                        huoban.setHuoBanWeekIndex(weekfree.getId());
                        Module.logger.info((Object)new StringBuffer().append("set weekfree: ").append("roleid:").append(this.roleId).append("huobans:").append(huobanId));
                        continue block8;
                    }
                    case 3: {
                        if (finalState > 0L) {
                            if (huoban.getHuoBanWeekIndex() == weekfree.getId()) continue block8;
                            long addtime = CalendarUtil.getThisWeekSunday() - nowTime;
                            huoban.addHuoBanTimes(addtime);
                            huoban.setHuoBanWeekIndex(weekfree.getId());
                            Module.logger.info((Object)new StringBuffer().append("set weekfree add: ").append("roleid:").append(this.roleId).append("huobans:").append(huobanId).append(",state").append(huoban.getHuoBanFinalState()));
                            continue block8;
                        }
                        huoban.setHuoBanState(2);
                        huoban.setHuoBanWeekIndex(weekfree.getId());
                        continue block8;
                    }
                }
                continue;
            }
            switch (nState) {
                case 2: {
                    huoban.setHuoBanState(0);
                    huoban.setHuoBanWeekIndex(weekfree.getId());
                    Module.logger.info((Object)new StringBuffer().append("unset weekfree: ").append("roleid:").append(this.roleId).append("huobans:").append(huobanId));
                    break;
                }
            }
        }
    }

    public void sendHuoBanZhenRong() {
        SZhenrongInfo szhenrongInfo = new SZhenrongInfo();
        HuoBanZhenRongColumn zhenrongCol = HuoBanZhenRongColumn.getZhenRongColumn(this.roleId, false);
        szhenrongInfo.dangqianzhenrong = zhenrongCol.getCurrentZhenRong();
        Map<Integer, HuoBanZhenrongInfo> szhenrong = zhenrongCol.getZhenRong();
        SHeroWeekFreeInfo weekfree = Module.getInstance().getHeroWeekFreeInfo();
        if (weekfree == null) {
            logger.debug((Object)"weekfree is null");
            return;
        }
        ArrayList<Integer> vipHuoban = new ArrayList<Integer>();
        int vipCount = this.huobancolumn.getViphuoban();
        if (vipCount != 0) {
            for (int i = 0; i < vipCount; ++i) {
                Integer huobanid = (Integer)weekfree.vipheros.get(i);
                if (huobanid == null) continue;
                vipHuoban.add(huobanid);
            }
        }
        for (Map.Entry<Integer, HuoBanZhenrongInfo> zr : szhenrong.entrySet()) {
            ZhenrongInfo zInfo = new ZhenrongInfo();
            zInfo.zhenfa = zr.getValue().getZhenfa();
            ArrayList<Integer> nowhuobanKeys = new ArrayList<Integer>(4);
            nowhuobanKeys.addAll(zr.getValue().getHuoban());
            for (Integer huobanId : zr.getValue().getHuoban()) {
                HuoBan huoban = this.getHuoBan(huobanId);
                if (huoban == null) {
                    return;
                }
                Long nState = huoban.getHuoBanFinalState();
                if (nState == 2L && !weekfree.getHeros().contains(huobanId) && !vipHuoban.contains(huobanId)) {
                    nState = 0L;
                }
                if (nState == 0L) {
                    nowhuobanKeys.remove(huobanId);
                    int tmpId = this.getHuoBanInfoByType(huoban.getType(), zInfo.huobanlist, nowhuobanKeys);
                    if (tmpId == 0) continue;
                    zInfo.huobanlist.add(tmpId);
                    continue;
                }
                zInfo.huobanlist.add(huobanId);
            }
            zr.getValue().getHuoban().clear();
            zr.getValue().getHuoban().addAll(zInfo.huobanlist);
            szhenrongInfo.zhenrongxinxi.put(zr.getKey(), zInfo);
            if (zr.getKey().intValue() != zhenrongCol.getCurrentZhenRong()) continue;
            this.setFightHuoBans(zInfo.huobanlist);
        }
        Transaction.tsendWhileCommit((long)this.roleId, (Protocol)szhenrongInfo);
    }

    public void sendHuoBanList() {
        SHuobanList snd = new SHuobanList();
        Map<Integer, SHeroBaseInfo> huobanMap = Module.getInstance().getHuoBanBaseInfo();
        int roleLevel = Properties.selectLevel((Long)this.roleId);
        ArrayList<Integer> weekFreeHuoban = new ArrayList<Integer>();
        SHeroWeekFreeInfo weekfree = Module.getInstance().getHeroWeekFreeInfo();
        if (weekfree == null) {
            logger.info((Object)("weekfree is null:" + this.roleId));
            return;
        }
        weekFreeHuoban.addAll(weekfree.getHeros());
        int vipCount = this.huobancolumn.getViphuoban();
        if (vipCount != 0) {
            for (int i = 0; i < vipCount; ++i) {
                Integer huobanid = (Integer)weekfree.vipheros.get(i);
                if (huobanid == null) continue;
                weekFreeHuoban.add(huobanid);
            }
        }
        long nowTime = System.currentTimeMillis();
        for (Integer heroId : huobanMap.keySet()) {
            HuoBanInfo sInfo = new HuoBanInfo();
            HuoBan huoban = this.getHuoBan(heroId);
            if (huoban == null) {
                xbean.HuoBanInfo heroInfo = null;
                heroInfo = Pod.newHuoBanInfo();
                SHeroBaseInfo hero = Module.getInstance().getHuoBanBaseInfo().get(heroId);
                if (weekFreeHuoban.contains(heroId)) {
                    if (heroInfo.getState() == 0) {
                        heroInfo.setState(2);
                        heroInfo.setSettimes(nowTime);
                        heroInfo.setWeekindex(weekfree.getId());
                    } else if (heroInfo.getState() == 3) {
                        heroInfo.setState(3);
                        heroInfo.setSettimes(nowTime);
                        heroInfo.setWeekindex(weekfree.getId());
                        Long nDays = heroInfo.getTimes();
                        nDays = nDays + CalendarUtil.getTimeByContinueDays((int)7);
                        heroInfo.setTimes(nDays.longValue());
                    }
                } else if (heroInfo.getState() == 0) {
                    heroInfo.setState(0);
                    heroInfo.setSettimes(nowTime);
                    heroInfo.setWeekindex(weekfree.getId());
                }
                if (hero.creater_give == 1) {
                    heroInfo.setState(1);
                    heroInfo.setSettimes(nowTime);
                    heroInfo.setWeekindex(weekfree.getId());
                } else if (hero.creater_give == 2) {
                    heroInfo.setState(1);
                    heroInfo.setSettimes(nowTime);
                    heroInfo.setWeekindex(weekfree.getId());
                }
                heroInfo.setId(heroId.intValue());
                heroInfo.setLevel(roleLevel);
                heroInfo.setInfight(0);
                heroInfo.setType(hero.getType());
                this.addHuoBan(heroId, heroInfo);
                huoban = this.getHuoBan(heroId);
            }
            sInfo.huobanid = heroId;
            sInfo.infight = huoban.getInfight();
            sInfo.weekfree = huoban.getWeekFree();
            sInfo.state = huoban.getHuoBanFinalState();
            snd.huobans.add(sInfo);
            if (snd.huobans.size() < 200) continue;
            if (Transaction.current() != null) {
                Transaction.tsendWhileCommit((long)this.roleId, (Protocol)snd);
            } else {
                Onlines.getInstance().send(Long.valueOf(this.roleId), (Protocol)snd);
            }
            snd = new SHuobanList();
        }
        if (snd.huobans.size() > 0) {
            Transaction.tsendWhileCommit((long)this.roleId, (Protocol)snd);
        }
    }

    public void sendHuoBanListOnChange() {
        this.setWeekFreeHuoBan();
        this.sendHuoBanZhenRong();
        this.sendHuoBanList();
    }

    public void addHuoBan(int huobanId, xbean.HuoBanInfo huobanInfo) {
        if (this.huobancolumn.getHuobans().containsKey(huobanId)) {
            this.huobancolumn.getHuobans().remove(huobanId);
        }
        this.huobancolumn.getHuobans().put(huobanId, huobanInfo);
    }

    public boolean setFightHuoBans(List<Integer> fights) {
        for (Integer huobanId : fights) {
            HuoBan huoban = this.getHuoBan(huobanId);
            if (huoban.canFight()) continue;
            return false;
        }
        this.huobancolumn.getFighthuobans().clear();
        this.huobancolumn.getFighthuobans().addAll(fights);
        Role role = RoleManager.getInstance().getRoleByID(this.roleId);
        if (role != null) {
            role.setHuobanSize(this.huobancolumn.getFighthuobans().size());
        }
        return true;
    }

    public List<Integer> getFightHuobanKeys() {
        this.setWeekFreeHuoBan();
        ArrayList<Integer> huobanKeys = new ArrayList<Integer>(4);
        ArrayList<Integer> nowhuobanKeys = new ArrayList<Integer>(4);
        nowhuobanKeys.addAll(this.huobancolumn.getFighthuobans());
        boolean change = false;
        for (Integer huobanId : this.huobancolumn.getFighthuobans()) {
            HuoBan huoban = this.getHuoBan(huobanId);
            if (huoban == null) {
                return null;
            }
            Long nState = huoban.getHuoBanFinalState();
            if (nState == 0L) {
                nowhuobanKeys.remove(huobanId);
                int tmpId = this.getHuoBanInfoByType(huoban.getType(), huobanKeys, nowhuobanKeys);
                if (tmpId == 0) continue;
                huobanKeys.add(tmpId);
                change = true;
                continue;
            }
            huobanKeys.add(huobanId);
        }
        this.huobancolumn.getFighthuobans().clear();
        this.huobancolumn.getFighthuobans().addAll(huobanKeys);
        if (change) {
            HuoBanZhenRongColumn zhenrongCol = HuoBanZhenRongColumn.getZhenRongColumn(this.roleId, false);
            zhenrongCol.setCurrentZhenRongHuoBan(huobanKeys);
            this.sendHuoBanZhenRong();
            this.sendHuoBanList();
        }
        return huobanKeys;
    }

    public Map<Integer, HuoBan> getAllHuoBans() {
        HashMap<Integer, HuoBan> huobans = new HashMap<Integer, HuoBan>();
        for (Map.Entry entry : this.huobancolumn.getHuobans().entrySet()) {
            huobans.put((Integer)entry.getKey(), HuoBan.getHuoBan((xbean.HuoBanInfo)entry.getValue(), this.readonly));
        }
        return huobans;
    }

    public void setVipHuoBanCnt(int cnt) {
        this.huobancolumn.setViphuoban(cnt);
    }

    public int getVipHuoBanCnt() {
        return this.huobancolumn.getViphuoban();
    }
}

